require 'fileutils'

module Cubic
  module Generator
    # View fulfils the V in the MVC pattern. The html documents generated by
    # the View generator will sit in your app/views directory, waiting
    # to be served by your application.
    class View < Base
      include FileUtils

      # Creates a hash that will be used for file generation purposes
      def design(dir, action)
        @files << { directory: "#{Config[:root_path]}/app/views/#{dir}",
                    path: "/app/views/#{dir}/#{action}.#{Config[:html_type]}",
                    content: "%p Coming to you from in #{dir}/#{action}" }
      end

      def generate
        @files.each do |info|
          mkdir_p(info[:directory]) unless Dir.exist?(info[:directory])
          path = File.join(Config[:root_path], info[:path])
          File.open(path, 'w') { |f| f.write(info[:content]) }
        end
      end
    end
  end
end
